###### functions used by oPatchy
# op_check_url <url> <user> <passwd> <patchlevel> - check if
#          the specified can be reached 
# op_patch <patchlevel>        - retrieve and apply patch <patchlevel>

#########################################################
# op_check_url <url> <user> <passwd>
# check if the specified can be reached
op_check_url()
{
   
   CHECK_URL=$1
   # check the patch download URL
   if [ -z "${CHECK_URL}" ] ; then
      echo "No URL passed. exiting"
      return 1
   fi

   # check if wget binary exists or exit
   if [ -z "${OP_WGET}" ] ; then
      echo "No application to retreive patches OP_WGET defined in site config file. Exiting"
      return 2
   elif [ ! -x "${OP_WGET}" ] ; then
      echo "The application to retreive patches \'${OP_WGET}\' defined in site config file does not exist. Exiting"
      return 3
   fi
   TEST_WGET=${OP_WGET}
   
   CHECK_USER=$2
   CHECK_PASSWD=$3
   # check if distribution URL is authenticated and no improper characters
   if [ -n "${CHECK_USER}" ] && 
      [ "${CHECK_USER}" == "${CHECK_USER//[^0-9a-z]/}" ] &&
      [ -n "${CHECK_PASSWD}" ] && 
      [ "${CHECK_PASSWD}" == "${CHECK_PASSWD//[^-a-zA-Z0-9_@%.]/}" ] ; then
      # if using curl
      # OP_WGET="${OP_WGET} -u ${OP_DIST_USER}:${OP_DIST_PASSWD}"
      # if using wget
      TEST_WGET="${TEST_WGET} --user=${OP_DIST_USER} --password=${OP_DIST_PASSWD}"
   fi 
   
   
   # check if the URL can be reached
   # !!!!! TBD

   return 0

}

#########################################################
# op_patch <patchlevel>
# retrieve and apply patch <patchlevel>
op_patch()
{

   LP_LEVEL=$1
   echo "Applying patch ${LP_LEVEL}"
   
   if [ "${LP_LEVEL}" != "${LP_LEVEL//[^0-9]/}" ] ; then
      echo "Patch name should contain only digits. Exiting"
      return 1
   fi
   
   
   # wordir cleaning
   echo /bin/rm -Rf ${OP_WORKDIR}/${LP_LEVEL}
   
   # register patch as applied
   cat <<< ${LP_LEVEL} > ${OP_ETC_DIR}/patchlevel.local
   return 0
   
}

#########################################################
# 
# 




#########################################################
# 
# 




#########################################################
# 
# 



#########################################################
# 
# 




#########################################################
# 
# 




#########################################################
# 
# 




#########################################################
# 
# 




#########################################################
# 
# 




#########################################################
# 
# 





#########################################################

 